--Revised 10/19 to provide additional customers and to use resolution
-- added a resolution function 'bit_or
-- added a resolved type
-- and an array type of the resolved type
-- then made all the buttons arrays of the resolved type


--CSE561 Fall 1994
--Midterm Project Elevator
--Due date: November 2
--
--You are to design and test an elevator control system for a 4 story
--building. 


--     Design the control system for an elevator in a building of 4
--floors. Use entirely behavioral facilities of VHDL. Use no
--components or entities with ports.  Your control system controls
--three signals, motor_control, door_control, and sweep_light. 

--     Motor_control has three possible values, (-1, 0 , 1)
--       which represent (move down, stop, and move up)
--     Door_control has two possible values,    (0,1)
--        which represent (close and open)
--     sweep_light has three possible values, (-1,0 1)
--          if sweep_light = -1 then the elevator intends to satisfy
--          all requests for downward service before servicing upward
--           service requests. If sweep_light = 1, the upward requests
--          have priority. If sweep_light = 0 the elevator control
--          has no commitment to sweep in either direction.
--
--     The controller has the following inputs:
--          floor_buttons : bit_vector( 1 to 4);
--          up_buttons    : bit_vector( 1 to 4);
--          down_buttons  : bit_vector( 1 to 4);
--     The floor buttons are the buttons inside the elevator used to
--     designate that a rider wishes to go to floor i. So if a rider
--     wishes to go to floor 3, he/she will push  the appropriate
--     button, and it will be detected by floor_buttons(3) becoming
--     '1' and remaining at that value as long as the button is
--     depressed. The other inputs are similar. up_buttons are used
--     to detect that a person on floor i wishes to go up. Similarly,
--     if a person on floor 4 wishes to go down, he/she will press
--     the down button on floor 4, and it will be seen as
--     down_button(4) becoming '1' for a time. Perhaps it is not
--     sensible to have a 'down' button on the first floor, or  an
--     'up' button on the top floor. Omit these if you wish.
     
--     The controller has an input, position, that helps it to know
--     where the  elevator is. This is an integer signal whose
--     'normal' range is 10 to 40. The interpretation is that if
--     position is equal to 10,20,30,40 then the elevator is at floor
--     1,2,3,4 respectively, When position has a value between 11 and
--     19 the elevator is between the 1st and 2nd floors. Similarly
--     for the other possible values.

--     The controller has an input signal, door_position,  that is an
--     integer, either 0, or 1, representing that the door is either
--     closed or open, respectively.
--
--     The design task is to sense the inputs and control the outputs
--     of the controller in a sensible way. Safety requires that the
--     elevator should not move until the door is closed, and that
--     the door should not open unless the elevator is at a floor.
--     Satisfactory operation requires that requests for service be
--     dealt with in a satisfactory way. For example, if the
--     controller is aware that someone on floor 3 wishes to go down,
--     and the elevator is on floor 4, then the elevator should go to
--     floor 3, stop and open the door. You should derive sensible
--     specifications based on your own ideas of good elevator
--     operation. Of course, a very simple control system might
--     suffice. For example, a control system that caused the
--     elevator to continuously go up to the top and then down to the
--     bottom, always stopping at every floor is simple and will
--     eventually service all requests. This control system pays no
--     attention to the requests for service. You can improve on this
--     primitive level of service.

--Other information:
--Here is a simple elevator control system. It includes models for
--how the motor affects the position, and how a person wanting
--to go from floor 1 to floor 3 would behave. 
--
--You can use this as a beginning point for the project. When the project
--is evaluated we may include many people, needing various elevator
--services.
--
entity elevator is end elevator;

architecture beh of elevator is
-- first define the resolution function
  function bit_or(invals : bit_vector) return bit is
    variable result : bit := '0';
    begin
      for i in invals'range loop
       result := result or invals(i);
      end loop;
      return result;
  end bit_or; 

--Now define the resolved type, res_bit;

subtype res_bit is bit_or  bit;
type res_bit_vector is array(integer range <>) of res_bit;

  signal position      : integer := 10;  -- first floor
  signal door_position : integer := 0;   -- closed
  signal door_control  : integer := 0;   -- close
-- now make the buttons resolved signals
  signal floor_buttons, up_buttons, down_buttons: res_bit_vector(1 to 4);
  signal sweep_light : integer := 0;
  signal motor_control : integer := 0;   -- stopped	 
  signal tm : time := 0 sec;

begin 

    -- this process models the way the elevator position
    -- is affected by the motor
	process 
	 -- I intend to initialize position to 10
         -- and motor_control to 0
           begin
 	     wait on motor_control, position;
		if (motor_control /= 0)
                     then position <= position + motor_control after 0.2 sec;
		else position <= position;  -- to cancel scheduled changes
                end if;

             assert (position <= 40)
                report "Blast off"
		severity error;

	     assert (position >= 10)
                report "Diving"
	        severity error;		
	end process;                     

     -- this process models the way the door position 
     -- depends on the door control
	door_position <= door_control after 1 sec;

      -- this process models the behavior of someone wanting
      -- to go from floor 1 to floor 3
	process -- person 1
          begin
            wait for 1 sec;
            up_buttons(1) <= '1', '0' after 0.5 sec;
	    if not(( door_position = 1) and (position = 10))
              then wait until ((door_position = 1) and (position = 10));
            end if;
	    floor_buttons(3) <= '1', '0' after 0.5 sec;
	    wait until (position = 30) and (door_position = 1);
            wait;
        end process;

      -- this process models the behavior of someone wanting
      -- to go from floor 2 to floor 4
	process -- person 2
          begin
            wait for 1 sec;
            up_buttons(2) <= '1', '0' after 0.5 sec;
	    if not(( door_position = 1) and (position = 20))
              then wait until ((door_position = 1) and (position = 20));
            end if;
	    floor_buttons(4) <= '1', '0' after 0.5 sec;
	    wait until (position = 40) and (door_position = 1);
            wait;
        end process;

      -- this process models the behavior of someone wanting
      -- to go from floor 3 to floor 2
	process 
          begin
            wait for 2 sec;
            down_buttons(3) <= '1', '0' after 0.5 sec;
	    if not(( door_position = 1) and (position = 30))
              then wait until ((door_position = 1) and (position = 30));
            end if;
	    floor_buttons(2) <= '1', '0' after 0.5 sec;
	    wait until (position = 20) and (door_position = 1);
            wait;
        end process;

        assert (door_position = 0) or (motor_control = 0)
          report "OHSA inspector is coming"
          severity error;


    -- the following models a very simple elevator control system
    -- stop at every floor. You are to replace it with your own 
    -- control system design. 
    process
      begin
        if ((position mod 10) = 0) 
          then
            motor_control <= 0;
            door_control <= 1;
            if door_position /= 1 then 
               wait until door_position = 1;
            end if;
            wait for 10 sec;
            door_control <= 0;
            wait until door_position = 0;
            motor_control <= sweep_light; 
         end if;
        wait on position;
     end process;

     sweep_light <= 1  when position = 10 else
                    -1 when position = 40 else
                    sweep_light;
                    

end beh;





